//
//  AboutViewController.m
//  BBSApp
//
//  Created by Ki Woon Sung on 7/25/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "AboutViewController.h"
#import "AboutView.h"

@implementation AboutViewController

@synthesize aboutView;
@synthesize myTextView;
@synthesize containerView;
@synthesize frontViewIsVisible;
@synthesize testImageView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
	if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
		// Initialization code
		self.title = @"About";
		self.tabBarItem.image = [UIImage imageNamed:@"about.png"];
		
		// set the long name shown in the navigation bar
		self.navigationItem.title=@"About";
        
        self.frontViewIsVisible = YES;
//		
//		// create a custom navigation bar button and set it to always say "back"
//		UIBarButtonItem *temporaryBarButtonItem=[[UIBarButtonItem alloc] init];
//		temporaryBarButtonItem.title=@"Back";
//		self.navigationItem.backBarButtonItem = temporaryBarButtonItem;
//		[temporaryBarButtonItem release];
	}
	return self;
}


// Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
    NSLog(@"AboutViewController's view is loaded");
    
    CGSize preferredAboutViewSize = CGSizeMake(256, 200);

    // Create and store a container view
//    CGRect viewRect1 = CGRectMake(0,0,
//                                 preferredAboutViewSize.width,
//                                 preferredAboutViewSize.height);
    
    CGRect viewRectFull = [[UIScreen mainScreen] applicationFrame];
    
//    UIView *localContainerView = [[UIView alloc] initWithFrame:[[UIScreen mainScreen] applicationFrame]];
    UIScrollView *localContainerView = [[UIScrollView alloc] initWithFrame:viewRectFull];
    localContainerView.pagingEnabled = NO;
    localContainerView.contentSize = CGSizeMake(localContainerView.frame.size.width, localContainerView.frame.size.height *1);
    localContainerView.showsVerticalScrollIndicator = YES;
    localContainerView.scrollsToTop = NO;
    localContainerView.delegate = self;
    localContainerView.autoresizesSubviews = YES;
    
    self.containerView = localContainerView;
    [localContainerView release];
    
    containerView.backgroundColor = [UIColor whiteColor];
    
//    CGRect viewRect = CGRectMake((containerView.bounds.size.width-preferredAboutViewSize.width)/2, 
//        (containerView.bounds.size.height-preferredAboutViewSize.height)/2-40,
    CGRect viewRect = CGRectMake(0,0,
        preferredAboutViewSize.width,
        preferredAboutViewSize.height);
    
    // Create the about view
    AboutView *localAboutView = [[AboutView alloc] initWithFrame:viewRect];
//    AboutView *localAboutView = [[AboutView alloc] initWithFrame:[[UIScreen mainScreen]applicationFrame]];
    self.aboutView = localAboutView;
    [localAboutView release];
    
    // testing: draw the text field
   // CGRect rect1 = CGRectMake(0.0, 0.0, 150.0, 50.0);
    CGRect rect2 = CGRectMake(0.0, 50.0, 150.0, 250.0);
    
    UITextView *localTextView = [[[UITextView alloc] initWithFrame:rect2] autorelease];
    localTextView.textColor = [UIColor blackColor];
    localTextView.font = [UIFont fontWithName:@"Arial" size:12.0];
    localTextView.backgroundColor = [UIColor grayColor];
    [localTextView setAutoresizingMask:UIViewAutoresizingFlexibleHeight];
    
    localTextView.text = @"fakefake.fake.fakefake.fake.fakefake.";
    self.myTextView = localTextView;

    [localTextView release];
    
    
    // Add the about view to the containerView
    [containerView addSubview:aboutView];
   // [containerView addSubview:myTextView];
    
    self.myTextView.text = @".fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake.fakefake.fake";
    [self.myTextView scrollRangeToVisible:NSMakeRange([self.myTextView.text length], 0)]; 

    
    aboutView.viewController = self;
    self.view = containerView;

}


/*
 If you need to do additional setup after loading the view, override viewDidLoad.
- (void)viewDidLoad {
}
 */


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
}


#pragma mark UIScrollViewDelegate

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView {
    NSLog(@"AboutViewController: scrollViewDidEndDecelerating");
}


- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    NSLog(@"AboutViewController: scrollViewDidScroll");
    
    
}


@end
