//
//  BBSPublisher.h
//  BBSApp
//
//  Created by Kiwoon Sung on 8/5/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>


typedef enum {
    kTCPServerCouldNotBindToIPv4Address = 1,
    kTCPServerCouldNotBindToIPv6Address = 2,
    kTCPServerNoSocketsAvailable = 3,
} TCPServerErrorCode;


@interface BBSPublisher : NSObject {
    NSNetService *_netService;
    uint16_t _port;
	CFSocketRef _ipv4socket;
}

@property (nonatomic, retain) NSNetService *netService;
@property uint16_t port;

- (id)initWithNewPort:(NSUInteger)newPort;
- (BOOL)initSocket;
- (void)testSocket;
- (BOOL)enableBonjour;

@end
