//
//  BonjourMonitor.h
//  BBSApp
//
//  Created by Kiwoon Sung on 8/2/08.
//  Copyright 2008 Columbia University. All rights reserved.
//


#import <UIKit/UIKit.h>
#import <Foundation/NSNetServices.h>

@interface BonjourMonitor : NSObject {
	NSNetServiceBrowser *_netServiceBrowser;
    NSNetService *_netService; 
    
    // Keep track of available services
    NSMutableArray *_netServices;
    
    // Kepp track of search status
    BOOL searching;
    
    // Data to be intercommunicated
    NSMutableArray *_listItemInformation; // add ItemInformation objects only
}

@property (nonatomic, retain) NSNetServiceBrowser* netServiceBrowser;
@property (nonatomic, retain) NSNetService *netService;
@property (nonatomic, retain) NSMutableArray *netServices;
@property (nonatomic, retain) NSMutableArray *listItemInformation;

- (void)handleError:(NSNumber *)error;
- (NSString*) transmogrify:(NSString*)aString;
- (void)netServiceBrowser:(NSNetServiceBrowser*)netServiceBrowser didRemoveDomain:(NSString*)domain moreComing:(BOOL)moreComing;
- (void)netServiceBrowser:(NSNetServiceBrowser*)netServiceBrowser didFindDomain:(NSString*)domain moreComing:(BOOL)moreComing;

- (void)startMonitoring;
- (void)stopMonitoring;


// Trial
- (NSString *)getMeaninglessString;

@end
