/*
 *  Contants.h
 *  BBSApp
 *
 *  Created by Kiwoon Sung on 7/26/08.
 *  Copyright 2008 Columbia University. All rights reserved.
 *
 */

#pragma mark User Interface Related Macros

// Control dimensions
#define kUIProgressBarWidth		160.0
#define kUIProgressBarHeight	20.0
// UIActivityIndicator size
#define kActivityIndicatorSize	40.0
#define kActivityIndicatorXOrigin 150.0
#define kActivityIndicatorYOrigin 180.0

// UITableView section header heights;
#define kSectionHeaderForItemList 25.0

// UITableView row heights for each table entry
#define kLocalItemEntryRowHeight 50.0;

// UITableView row heights
#define kUIRowHeight			50.0
#define kUIRowLabelHeight		22.0

// Cell view for the item information
#define ITEM_NAME_FONT_SIZE 16.0
#define SHORT_DESCRIPTION_FONT_SIZE 13.0
#define ITEM_COUNT_FONT_SIZE 24.0

#define LEFT_COLUMN_OFFSET 10
#define LEFT_COLUMN_WIDTH 250

#define MIDDLE_COLUMN_OFFSET 180
#define MIDDLE_COLUMN_WIDTH 100

#define UPPER_ROW_TOP 4
#define LOWER_ROW_TOP 24

#define ODD_ROW_COLOR lightGrayColor
#define EVEN_ROW_COLOR grayColor

// General

// Limit the number of parsed item to 50. Otherwise the application runs very slowly on the device.
#define MAX_ITEMS 50

// Size for the item
#define MIN_ROW_HEIGHT 50
#define MAX_ROW_HEIGHT 400 // Don't allow to use the height bigger than this. If needed, provide the scroll property to the corresponding controls.

#define X_ORIGIN_ITEM_FIELD 7.0
#define Y_ORIGIN_ITEM_FIELD 7.0
#define X_MARGIN_ITEM_FIELD 7.0
#define X_MARGIN_ITEM_VALUE 10.0
#define X_RIGHT_MARGIN_ITEM_VALUE 15.0;
#define Y_MARGIN_ITEM_FIELD 10.0

#define MARGIN_BETWEEN_FIELD 30.0
#define MARGIN_BETWEEN_VALUE 3.0

// The maximum number of the lines to be displayed for the information of each field in the item.
// According to this number, the total lines of the detail information for each field are limited.
// However, if the contents of the field is not big enough to fill the number of lines, the next 
// field information label will be placed right after the end of the rect that describes the 
// previous field information
#define MAX_NUMBER_LINE_ITEM_FIELD 5;

// ITEM FIELD
#define ITEM_FIELD_TITLE_FONT_SIZE 18.0
#define ITEM_FIELD_VALUE_FONT_SIZE 16.0


#pragma mark Zero Configuration Netwrok Related Macros
#define _7DS_SERVICE_NAME @"_7dsbbs"
#define DOMAIN_NAME @"_local"
#define PROTOCOL_NAME @"_tcp"
#define FULL_SERVICE_NAME @"_7dsbbs._tcp._local."

// HTTP request
#define _REQUEST_TIME_OUT_IN_SEC 3.0

// List Views
#define STATUS_ON_TOOLBAR_WIDTH 300