//
//  CovertView.m
//  BBSApp
//
//  Created by Kiwoon Sung on 8/7/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "CovertView.h"


@implementation CovertView


@synthesize viewController;

- (id)initWithFrame:(CGRect)frame {
	if (self = [super initWithFrame:frame]) {
		// Initialization code
        viewController = nil;
        self.backgroundColor = [UIColor whiteColor];
        
	}
	return self;
}

- (void)loadView {
    NSLog(@"CovertView: loadView");
    

}


- (BOOL)canBecomeFirstResponder {
    return YES;
}


- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    NSLog(@"CovertView: touchesBegan");
}



- (void)drawRect:(CGRect)rect {
    NSString *itemNameFakeString = @"abcdef abcdef abcdef abcdef abcdef abcdef abcdef abcdef abcdef";
    UIFont *font = [UIFont boldSystemFontOfSize:13];
    
    
    CGSize stringSize = [itemNameFakeString sizeWithFont:font];
    CGRect rectAt1 = CGRectMake(0.0, 0.0, 250.0, stringSize.height * 3);
    NSLog(@"stringSize.height X 3 = %f", stringSize.height * 3);
    
    CGSize drawnStringSize = [itemNameFakeString drawInRect:rectAt1 withFont:font lineBreakMode:UILineBreakModeWordWrap];
    NSLog(@"drawnStringSize = %f", drawnStringSize.height);
    if (drawnStringSize.height < stringSize.height) {
        // find the new location since the view is smaller than expacted
        // Or, just overlap the view by using drawnStringSize.height as the added height
    }
    else {
        
    }
    
    CGRect rectAt2 = CGRectMake(0.0, drawnStringSize.height, 250.0, stringSize.height *3);
    drawnStringSize = [@"New String Begins Here" drawInRect:rectAt2 withFont:font lineBreakMode:UILineBreakModeWordWrap];
    NSLog(@"drawnStringSize = %f", drawnStringSize.height);

    UILabel *labelTest = [[UILabel alloc] initWithFrame:rect];
    [labelTest setAutoresizingMask:UIViewAutoresizingFlexibleHeight];
    [labelTest setBackgroundColor:[UIColor whiteColor]];
    [labelTest setTextAlignment:UITextAlignmentLeft];
    [labelTest setBaselineAdjustment:UIBaselineAdjustmentAlignBaselines];
    [labelTest setText:itemNameFakeString];
    //    [labelTest setNumberOfLines:3];
    [labelTest sizeToFit];
    
    NSInteger temp = [labelTest numberOfLines];
    NSLog(@"%d", temp);
    //[labelTest drawRect:rect];
    
    [self createImageButton];

}


- (void)dealloc {
    [viewController release];
    
	[super dealloc];
}


- (void)action:(id)sender
{
	NSLog(@"UIButton was clicked");
}

#define kStdButtonWidth			106.0
#define kStdButtonHeight		40.0

- (void)createImageButton
{	
	// create a UIButton with just an image instead of a title
	
	UIImage *buttonBackground = [UIImage imageNamed:@"whiteButton.png"];
	UIImage *buttonBackgroundPressed = [UIImage imageNamed:@"blueButton.png"];
	
	CGRect frame = CGRectMake(0.0, 0.0, kStdButtonWidth, kStdButtonHeight);
	
	imageButton = [self buttonWithTitle:@""
                                 target:self
                               selector:@selector(action:)
                                  frame:frame
                                  image:buttonBackground
                           imagePressed:buttonBackgroundPressed
                          darkTextColor:YES];
	
	[imageButton setImage:[UIImage imageNamed:@"UIButton_custom.png"] forState:UIControlStateNormal];
    
}

- (UIButton *)buttonWithTitle:	(NSString *)title
                       target:(id)target
                     selector:(SEL)selector
                        frame:(CGRect)frame
                        image:(UIImage *)image
                 imagePressed:(UIImage *)imagePressed
                darkTextColor:(BOOL)darkTextColor
{	
	UIButton *button = [[UIButton alloc] initWithFrame:frame];
	// or you can do this:
	//		UIButton *button = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
	//		button.frame = frame;
	
	button.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
	button.contentHorizontalAlignment = UIControlContentHorizontalAlignmentCenter;
	
	[button setTitle:title forState:UIControlStateNormal];	
	if (darkTextColor)
	{
		[button setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
	}
	else
	{
		[button setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
	}
	
	UIImage *newImage = [image stretchableImageWithLeftCapWidth:12.0 topCapHeight:0.0];
	[button setBackgroundImage:newImage forState:UIControlStateNormal];
	
	UIImage *newPressedImage = [imagePressed stretchableImageWithLeftCapWidth:12.0 topCapHeight:0.0];
	[button setBackgroundImage:newPressedImage forState:UIControlStateHighlighted];
	
	[button addTarget:target action:selector forControlEvents:UIControlEventTouchUpInside];
	
    // in case the parent view draws with a custom color or gradient, use a transparent color
	button.backgroundColor = [UIColor clearColor];
    
	return button;
}




@end
