//
//  HTTPLauncher.m
//  BBSApp
//
//  Created by Kiwoon Sung on 8/5/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "HTTPLauncher.h"

// Imports for the internal Web server
#import "defs.h"


@implementation HTTPLauncher

@synthesize portString;

- (id) initWithPort:(NSString *)newPortString {
    self = [super init];
    if (self != nil) {
        self.portString = newPortString;
        didLaunchHTTPDaemon = NO;
    }
    return self;
}



- (void)runHTTPService:(id)sender {
    NSLog(@"thread: starting http daemong");
    
    struct shttpd_ctx	*ctx;
    
#ifndef _WIN32
    NSLog(@"ndef _WIN32");
	(void) signal(SIGCHLD, signal_handler);
	(void) signal(SIGPIPE, SIG_IGN);
#endif /* _WIN32 */
    
	(void) signal(SIGTERM, signal_handler);
	(void) signal(SIGINT, signal_handler);
    
//    char ch[1][100];
//    sprintf(ch[1], "%s", cString);
    char *argv[4]; // = {"./shttpd", "-ports", "20001"};

    argv[0] = (char *)malloc(100);
    argv[1] = (char *)malloc(100);
    argv[2] = (char *)malloc(100);
    argv[3] = NULL;
    argv[0] = (char *)[@"./shttpd" cStringUsingEncoding:NSUTF8StringEncoding];
    argv[1] = (char *)[@"-ports" cStringUsingEncoding:NSUTF8StringEncoding];
    argv[2] = (char *)[self.portString cStringUsingEncoding:NSUTF8StringEncoding];
    
    ctx = shttpd_init(4, argv);
    
	elog(E_LOG, NULL, "shttpd %s started on port(s) %s, serving %s",
         VERSION, ctx->options[OPT_PORTS], ctx->options[OPT_ROOT]);
    
	//while (exit_flag == 0)
    while (1)
		shttpd_poll(ctx, 10 * 1000);
    
    //	elog(E_LOG, NULL, "Exit on signal %d", exit_flag);
	shttpd_fini(ctx);
    
    //    return (EXIT_SUCCESS);
}


- (void)launchHTTPDaemon {
    if (!didLaunchHTTPDaemon) {
        didLaunchHTTPDaemon = YES;
        [NSThread detachNewThreadSelector:@selector(runHTTPService:) toTarget:self withObject:nil];
        
    }
}

static int	exit_flag;	/* Program termination flag	*/

static void
signal_handler(int sig_num)
{
	switch (sig_num) {
#ifndef _WIN32
        case SIGCHLD:
            while (waitpid(-1, &sig_num, WNOHANG) > 0) ;
            break;
#endif /* !_WIN32 */
        default:
            exit_flag = sig_num;
            break;
	}
}



@end
