//
//  Item.h
//  BBSApp
//
//  Created by Kiwoon Sung on 7/26/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "SLogger.h"
#import "ItemXMLReader.h"
#import "ItemDataSourceProtocol.h"

#import "BBSItemLocation.h"

@interface Item : NSObject {
    NSNetService *_netService;
    
    NSString *_fileName;
    NSString *_itemName;
    NSString *_shortDescription;
    NSURL *_URL; // When the XML file for an item is parsed, the URL is kept in this member.
    NSMutableArray *_fields;
    
    ItemXMLReader *m_streamingParser;
    
    BBSItemLocation location;
    
    // generated HTML string
    NSString *htmlString;
}

@property (nonatomic, retain) NSNetService *netService;
@property (nonatomic, retain) NSString *fileName;
@property (nonatomic, retain) NSString *itemName;
@property (nonatomic, retain) NSString *shortDescription;
@property (nonatomic, retain) NSURL *_URL;
@property (nonatomic, retain) NSMutableArray *fields;

//@property (nonatomic, retain) SLogger *logger;
@property (nonatomic, retain) ItemXMLReader *streamingParser;
@property BBSItemLocation location;

@property (nonatomic, retain) NSString *htmlString;

- (id)initWithNetService:(NSNetService *)netService fileName:(NSString *)fileName;
- (id)initWithFileNameInServer:(NSString *)fileName;
- (id)initWithFileNameInLocal:(NSString *)fileName;

- (void)generateItemInstanceByXMLWithNetService:(NSNetService *)netService fileName:(NSString *)fileName;
- (void)generateItemInstanceByXMLFromServer:(NSString *)fileName;
- (void)generateItemInstanceByXMLFromLocal:(NSString *)fileName;
- (void)printItem;
- (NSString *)generateHTMLString;

- (NSString *)getItemName;
- (NSString *)getShortDescription;
- (NSMutableArray *)getFields;
- (NSURL *)getURL;

@end
