//
//  ItemTableViewControllerTest.m
//  BBSApp
//
//  Created by Kiwoon Sung on 8/1/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "ItemTableViewControllerTest.h"


@implementation ItemTableViewControllerTest


@synthesize list;
@synthesize tableViewMember;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
	if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
		// Initialization code
        self.title = @"Test";
		self.tabBarItem.image = [UIImage imageNamed:@"about.png"];
//        self.tabBarItem = [[UITabBarItem alloc]initWithTabBarSystemItem:UITabBarSystemItemMostRecent tag:0];
        self.tabBarItem.title = @"Test";

		// set the long name shown in the navigation bar
		self.navigationItem.title=@"Testing";
        
        list = [[NSMutableArray alloc]initWithCapacity:2];
        [self generateTableEntries];
	}
	return self;
}

- (void)dealloc {
    [toolbar release];
    
    [super dealloc];
}


- (void)createToolbarItems
{	
	// match each of the toolbar item's style match the selection in the "UIBarButtonItemStyle" segmented control
	UIBarButtonItemStyle style = UIBarButtonItemStylePlain;
    
	// create the system-defined "OK or Done" button
    UIBarButtonItem *systemItem = [[UIBarButtonItem alloc]
                                   initWithBarButtonSystemItem:UIBarButtonItemStylePlain
                                   target:nil action:nil];
	systemItem.style = style;
	
	// flex item used to separate the left groups items and right grouped items
	UIBarButtonItem *flexItem = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace
                                                                              target:nil
                                                                              action:nil];
	
	// create a special tab bar item with a custom image and title
	UIBarButtonItem *infoItem = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"segment_tools.png"]
                                                                 style:style
                                                                target:self
                                                                action:@selector(action:)];
	
	// create a bordered style button with custom title
	UIBarButtonItem *customItem = [[UIBarButtonItem alloc] initWithTitle:@"debugging"
                                                                   style:style	// note you can use "UIBarButtonItemStyleDone" to make it blue
                                                                  target:self
                                                                  action:@selector(action:)];
	
	NSArray *items = [NSArray arrayWithObjects: systemItem, flexItem, customItem, infoItem, nil];
	[toolbar setItems:items animated:NO];
	
	[systemItem release];
	[flexItem release];
	[infoItem release];
	[customItem release];
}




// Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
//    CGRect screenRect = [[UIScreen mainScreen] applicationFrame];
	
	// setup our parent content view and embed it to your view controller
	//
	UIView *contentView = [[UIView alloc] initWithFrame:[[UIScreen mainScreen] applicationFrame]];
    contentView.autoresizesSubviews = YES;
	contentView.autoresizingMask = (UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight);
	contentView.backgroundColor = [UIColor groupTableViewBackgroundColor];	// use the table view background color
	self.view = contentView;
	[contentView release];
	
	// create the UIToolbar at the bottom of the view controller
	//
	toolbar = [UIToolbar new];
	toolbar.barStyle = UIBarStyleDefault;
	
	// size up the toolbar and set its frame
	[toolbar sizeToFit];
	CGFloat toolbarHeight = [toolbar frame].size.height - 15.0;
	CGRect mainViewBounds = self.view.bounds;
//    CGFloat toolbarYOrigin = self.navigationController.navigationBar.frame.size.height;
    CGFloat toolbarYOrigin = 0.0;
    NSLog(@"toobarYOrigin = %f", toolbarYOrigin);
	[toolbar setFrame:CGRectMake(0.0, //CGRectGetMinX(mainViewBounds),
								 toolbarYOrigin, //CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - (toolbarHeight * 2.0) + 2.0,
								 CGRectGetWidth(mainViewBounds),
								 toolbarHeight)];
	
	[self.view addSubview:toolbar];
	
//	currentSystemItem = UIBarButtonSystemItemDone;
	[self createToolbarItems];
    
    // Then create a table view. This will contain a scroll view in itself by default
    CGRect tableViewRect = CGRectMake(0.0, 
                                      toolbarYOrigin + toolbarHeight, 
                                      CGRectGetWidth(mainViewBounds), 
                                      CGRectGetHeight(mainViewBounds) - toolbarHeight - toolbarYOrigin);
    tableViewMember = [[UITableView alloc]initWithFrame:tableViewRect style:UITableViewStylePlain];
    tableViewMember.delegate = self;
    tableViewMember.dataSource = self;
    
    [self showTableFooter];
    
    [self.view addSubview:tableViewMember];
    
    
}
 

/*
 If you need to do additional setup after loading the view, override viewDidLoad.
- (void)viewDidLoad {
}
 */


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)generateTableEntries {
    [list addObject:[NSDictionary dictionaryWithObjectsAndKeys:
                     @"generate-feed", @"itemName",
                     nil]];
    
    [list addObject:[NSDictionary dictionaryWithObjectsAndKeys:
                     @"self-requesting", @"itemName",
                     nil]];
    
    [list addObject:[NSDictionary dictionaryWithObjectsAndKeys:
                     @"get hashed value", @"itemName",
                     nil]];
    
    [list addObject:[NSDictionary dictionaryWithObjectsAndKeys:
                     @"publish a post", @"itemName",
                     nil]];
    
}    


#pragma mark UITableView delegate methods

// decide what kind of accesory view (to the far right) we will use
- (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath
{
	return UITableViewCellAccessoryDisclosureIndicator;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [list count];
}

/*- (id)objectInListAtIndex:(NSUInteger)theIndex {
    NSLog(@"objectInListAtIndex: %d", theIndex);
    return [list objectAtIndex:theIndex];
}*/

/*- (void)getList:(id *)objsPtr range:(NSRange)range {
    [listItemInformation getObjects:objsPtr range:range];
}*/


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
    static NSString *MyIdentifier = @"MyIdentifier";

    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:MyIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:MyIdentifier] autorelease];
    }
    // Configure the cell
    cell.text = [[list objectAtIndex:indexPath.row] objectForKey:@"itemName"];


    return cell;
    //
//	static NSString *MyIdentifier = @"MyIdentifier";
//    NSLog(@"tableView:cellForRowAtIndexPath:indexPath.row=%d", indexPath.row);
//    
//  	UITableViewCell *cell = (UITableViewCell *)[tableView dequeueReusableCellWithIdentifier:MyIdentifier];
//	if (cell == nil) {
//		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:MyIdentifier] autorelease];
//	}
//
//    cell.text = @"Test";
//	return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    NSLog(@"ServerItemTableViewController clicked: row: %d", indexPath.row);
    
    switch (indexPath.row) {
        case 0:
            NSLog(@"generate feed");
            [self testGenerateFeed];
            break;
        case 1:
            NSLog(@"self-requesting");
            break;
        case 2:
            NSLog(@"get hashed value");
            break;
        case 3:
            NSLog(@"publish a post");
            break;
        default:
            break;
    }
    
}


- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
	return @"make it clear";
}

/*
 - (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
 
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 }
 if (editingStyle == UITableViewCellEditingStyleInsert) {
 }
 }
 */
/*
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
 return YES;
 }
 */
/*
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
 }
 */
/*
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
 return YES;
 }
 */

#pragma mark UITableViewDelegate Ends


- (void)showTableFooter {
    // See if anything worthy
    CGRect titleRect = CGRectMake(0, 50, 300, 45); 
    UILabel *tableTitle = [[UILabel alloc] initWithFrame:titleRect]; 
    tableTitle.textColor = [UIColor lightGrayColor]; 
    tableTitle.backgroundColor = [UIColor clearColor]; 
    tableTitle.opaque = YES; 
    tableTitle.font = [UIFont fontWithName:@"Arial" size:11]; 
    tableTitle.text = @"Copyright 2008 by Columbia University";
    tableTitle.textAlignment = UITextAlignmentCenter;
    
    tableViewMember.tableFooterView = tableTitle;
    
    [tableTitle release];
    
}    


#pragma mark TestProcedures

- (void)testGenerateFeed {
    LocalFeedGenerator *localFeedGenerator = [[LocalFeedGenerator alloc] init];
    [localFeedGenerator generateLocalFeed];
    [localFeedGenerator generateItemInformationList];
    [localFeedGenerator generateLocalAtomFeedFile];
}



@end
