//
//  ItemView.m
//  BBSApp
//
//  Created by Kiwoon Sung on 7/29/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "Contants.h"

#import "ItemView.h"


@implementation ItemView

//@synthesize itemObject = m_itemObject;
@synthesize viewController;

@synthesize itemName = m_itemName;
@synthesize shortDescription = m_shortDescription;
@synthesize fields = m_fields;
@synthesize _URL = m_URL;

- (id)initWithFrameAndItem:(CGRect)frame itemObject:(Item *)itemObject{
	if (self = [super initWithFrame:frame]) {
        self.backgroundColor = [UIColor whiteColor];
        

		// Initialization code
        viewController = nil;
        self.itemName = [itemObject itemName];
        self.shortDescription = [itemObject shortDescription];
        self.fields = [itemObject fields];
        self._URL = [itemObject _URL];
        
	}
	return self;
}


- (void)drawRect:(CGRect)rect {

    NSString *itemName = @"Field Name";
    UIFont *font = [UIFont boldSystemFontOfSize:ITEM_FIELD_TITLE_FONT_SIZE];
    CGSize stringSize = [itemName sizeWithFont:font];

    CGFloat screenWidth = [[UIScreen mainScreen] applicationFrame].size.width - X_MARGIN_ITEM_FIELD - X_ORIGIN_ITEM_FIELD - X_RIGHT_MARGIN_ITEM_VALUE;
    CGFloat previousHeight = 0.0;
    
    CGFloat allowedHeight = stringSize.height * MAX_NUMBER_LINE_ITEM_FIELD;
    
    // Use only this rect to display the string
    CGRect rectAt = CGRectMake(X_ORIGIN_ITEM_FIELD, Y_ORIGIN_ITEM_FIELD, screenWidth, allowedHeight);
    CGFloat addedHeight = Y_ORIGIN_ITEM_FIELD;
    
    CGSize drawnRectSize = [itemName drawInRect:rectAt withFont:font lineBreakMode:UILineBreakModeCharacterWrap];
    
    // Calculate the new position for the next field
    addedHeight = drawnRectSize.height + Y_ORIGIN_ITEM_FIELD;
    NSLog(@"addedHeight = %f", addedHeight);
    if (addedHeight < allowedHeight) {
        // find the new location since the view is smaller than expacted
        // Or, just overlap the view by using drawnStringSize.height as the added height
        previousHeight = previousHeight + addedHeight;
    }
    else {
        previousHeight = previousHeight + allowedHeight;
    }
    previousHeight += MARGIN_BETWEEN_VALUE;
    
    // Display the detail field value
    CGRect rectForDetail = CGRectMake(X_ORIGIN_ITEM_FIELD + X_MARGIN_ITEM_VALUE, previousHeight, screenWidth, allowedHeight);
//    NSString *valueString = @"1234567890123456789012345678901234567890123456789012345678901234567890";
    NSString *shortDescription = self.shortDescription;
    UITextView *valueTextView = [[UITextView alloc]initWithFrame:rectForDetail] ;
    valueTextView.textColor = [UIColor blackColor];
    valueTextView.font = [UIFont fontWithName:@"Arial" size:ITEM_FIELD_VALUE_FONT_SIZE];
    valueTextView.backgroundColor = [UIColor lightGrayColor];

    [valueTextView setEditable:NO];
    [valueTextView setAutoresizingMask:UIViewAutoresizingFlexibleHeight];
    
    valueTextView.text = shortDescription;
    [self addSubview:valueTextView];
    
}


- (void)dealloc {
    [viewController release];
    
	[super dealloc];
}


- (BOOL)canBecomeFirstResponder {
    return YES;
}


- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    NSLog(@"ItemView: touchesBegan");
}



@end
