//
//  ItemViewController.h
//  BBSApp
//
//  Created by Kiwoon Sung on 7/26/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "Item.h"
#import "ItemView.h"
#import "SLogger.h"
#import "BBSItemLocation.h"


// This class is to display the table cell view for the BBS item both from the server and a peer.
// After initializing an instance of this class, it is needed to call loadItem to assign the values
// to be displayed. 

@interface ItemViewController : UIViewController <UIScrollViewDelegate, UIWebViewDelegate> {
    // Obsolete members
    UITableView *myTableView;
    
    
    // changed to the single-view based screen
    UIScrollView *m_containerView;
    ItemView *itemView;
    UIToolbar *toolbar;

    
    NSString *m_fileName;
    Item *m_itemObject;
    SLogger *m_logger;
    
    BBSItemLocation downloadFrom;
    
    UIActivityIndicatorView *activityIndicatorView;
    NSString *givenSectionTitle;
}

@property (nonatomic, retain) UITableView *myTableView;
@property (nonatomic, retain) SLogger *logger;
@property (nonatomic, retain) NSString *fileName;
@property (nonatomic, retain) Item *itemObject;
@property (nonatomic, retain) ItemView *itemView;
@property (nonatomic, retain) UIScrollView *containerView;
@property (nonatomic) BBSItemLocation downloadFrom;

@property (nonatomic, retain) UIActivityIndicatorView *activityIndicatorView;
@property (nonatomic, retain) NSString *givenSectionTitle;

- (id)initWithItemFileName:(NSString *)fileName itemLocation:(BBSItemLocation)itemLocation;
- (id)initWithNetService:(NSNetService *)netService fileName:(NSString *)fileName;
- (void)loadItem:(NSString *)fileName;
- (void)loadItemWithNetService:(NSNetService *)netService fileName:(NSString *)fileName;
- (void)loadWebViewContentsTest:(UIWebView *)tempWebView;

- (void)showActivityIndicator;
- (void)hideActivityIndicator;

- (void)displayStatusOnToolbar:(NSString *)text 
                 showIndicator:(BOOL)showIndicator
                showStopButton:(BOOL)showStopButton
             showRefreshButton:(BOOL)showRefreshButton;

@end
