//
//  LocalFeedGenerator.h
//  BBSApp
//
//  Created by Kiwoon Sung on 9/5/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>

// The following procedure is applied ONLY to local form feed generating

// Generates a feed XML as a form of Atom
// 1. items in home/application directory are considered as a draft items
// 2. items sharing status in sub-folders are specified according to their directory
// 3. based on the above information, a form feed file is generated.
// every time the file is generated, this class does all above procedures: version 1.3
// this procedure will be refined later. not a big issue for now.


@interface LocalFeedGenerator : NSObject {
    NSMutableArray *fileNameList;
    NSMutableArray *itemInformationList;
}


@property (nonatomic, retain) NSMutableArray *itemInformationList;

- (void)generateLocalFeed;
- (void)generateItemInformationList;
- (void)generateLocalAtomFeedFile;
- (BOOL)createItemInformationEntryByFile:(NSString *)fullPath;
    
@end
