//
//  LocalFeedGenerator.m
//  BBSApp
//
//  Created by Kiwoon Sung on 9/5/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "LocalFeedGenerator.h"


@implementation LocalFeedGenerator

@synthesize itemInformationList;

- (id) init
{
    self = [super init];
    if (self != nil) {
        NSLog(@"LocalFeedGenerator initiated");
    }
    return self;
}

- (void)generateLocalFeed {
    NSLog(@"generateLocalFeed called");
    
    [self generateItemInformationList];
    [self generateLocalAtomFeedFile];
}


// There are exceptional cases.
// In the app directory, draft version of items are stored as well as local feed and remote feed xml.
- (void)generateItemInformationList {
    NSLog(@"generateItemInformationListByScanAndParse");

    NSString *publicFolderPath = @"";
    publicFolderPath = [publicFolderPath stringByAppendingString:NSHomeDirectory()];
    publicFolderPath = [publicFolderPath stringByAppendingString:@"/Documents/public"];
    
    
    NSDirectoryEnumerator *direnum = [[NSFileManager defaultManager] enumeratorAtPath:publicFolderPath];
    NSString *pname; 
    NSString *fileName = @"";
    BOOL result;
//    NSError **error = nil;
    
    while (pname = [direnum nextObject]) 
    { 
        NSLog(@"being scanned:%@", pname);
        if ([[pname pathExtension] isEqualToString:@"rtfd"]) 
        { 
            [direnum skipDescendents]; 
        } 
        else if ([[pname pathExtension] isEqualToString:@"xml"]) 
        { 
            fileName = [@"/" stringByAppendingString:[pname lastPathComponent]];
            
            NSString *fullPath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:fileName];
            NSLog(@"fullPath of XML file:%@", fullPath);
            
            // parse the xml file found
            result = [self createItemInformationEntryByFile:fullPath];
        }
    }
    if (result) NSLog(@"ok");
}


- (BOOL)createItemInformationEntryByFile:(NSString *)fullPath {
    NSLog(@"createItemInformationEntryByFile: called");
    
    return YES;
}


- (void)generateLocalAtomFeedFile {
    NSLog(@"generateLocalAtomFeedFile");
}


@end
