//
//  LocalItemTableViewController.h
//  BBSApp
//
//  Created by Ki Woon Sung on 7/25/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "ItemViewController.h"

@interface LocalItemTableViewController : UITableViewController {
    // Internal data 
    NSMutableArray *list; // this is only for composing the menu list based on the item information list
    NSMutableArray *listItemInformation;

    BOOL _isDataSourceAvailable;

    // UI controls
    UIActivityIndicatorView *_activityIndicatorView;    
    ItemViewController *itemViewController;
    UIToolbar *toolbar;
}

@property (nonatomic, retain) NSMutableArray *list;
@property (nonatomic, retain) NSMutableArray *listItemInformation;
@property (nonatomic, retain) UIActivityIndicatorView *activityIndicatorView;
@property (nonatomic, retain) ItemViewController *itemViewController;

- (void)showActivityIndicator;
- (void)hideActivityIndicator;
- (void)showTableHeader;
- (void)showTableFooter;

- (void)generateItemInformationListInLocalDirectory;
- (BOOL)copyDefaultXMLFileToDocumentsFolder:(NSString *)fileName error:(NSError **)outError;

- (void)uploadLocalItemsToServer;

- (void)displayStatusOnToolbar:(NSString *)text showIndicator:(BOOL)show;


@end
