//
//  PeerItemTableViewController.h
//  BBSApp
//
//  Created by Kiwoon Sung on 8/1/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

// This class is revised based on ServerItemTableViewControllerR2 class.
// In addition to the original version, this keeps information of NSNetService.
// It contains the data describing the peer node to which user wants to connect.


#import <UIKit/UIKit.h>

#import "ItemViewController.h"

@interface PeerItemTableViewController: UIViewController <UITableViewDelegate, UITableViewDataSource> {
    NSMutableArray *list;
    NSMutableArray *listItemInformation; // this is the mutable array to keep the item information list from the server
    
    BOOL _isDataSourceAvailable;
    BOOL didLaunchHTTPDaemon;
    
    // Response from the server
    NSMutableData *_receivedData;
    
    ItemViewController *itemViewController;
    
    UIToolbar *toolbar;
    UITableView *tableViewMember; // Don't use "tableView" as the name of the contained table view. It conflicts...
    UIActivityIndicatorView *_activityIndicatorView;
    
    // Added
    NSNetService *netService;
}

@property (nonatomic, retain) NSMutableArray *list;
@property (nonatomic, retain) NSMutableArray *listItemInformation;
@property (nonatomic, retain) UIActivityIndicatorView *activityIndicatorView;
@property (nonatomic, retain) ItemViewController *itemViewController;
@property (nonatomic, retain) UITableView *tableViewMember;
@property (nonatomic, retain) NSMutableData *receivedData;

// Added
@property (nonatomic, retain) NSNetService *netService;

- (id)initWithNetService:(NSNetService *)_netService;

- (void)createToolbarItems;
- (void)generateTableEntries;
- (void)showTableFooter;
- (void)refreshTable;

// Methods from the revision 1
- (void)generateItemListInformationByURL;
- (void)reloadItemInformationList:(NSData *)receivedData;
- (void)showActivityIndicator;
- (void)hideActivityIndicator;
- (void)showTableHeader;
- (void)showTableFooter;
- (void)displayStatusOnToolbar:(NSString *)text 
                 showIndicator:(BOOL)showIndicator
                showStopButton:(BOOL)showStopButton
             showRefreshButton:(BOOL)showRefreshButton;



@end
