//
//  SLogger.h
//  BBSApp
//
//  Created by Kiwoon Sung on 7/29/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>


@interface SLogger : NSObject {
    NSString *m_className;
    BOOL m_isDebugMode;
}

@property (nonatomic, retain) NSString *className;
@property (nonatomic, assign) BOOL isDebugMode;

- (id) initWithClassName: (NSString *)className isDebugMode:(BOOL)flag;

// Print the message whenever called
- (void) output: (NSString *)message;
// Print the message only when the debug mode flag of the class is set to true
// If the flag is no, the function works in the same way that output:message does
- (void) output: (NSString *)message showUpOnlyOnDebugMode:(BOOL)flag;
// Print the mssage only when the debug mode flag of the class is set to true
- (void) outputOnlyOnDebugMode:(NSMutableString *)message;

// The following three functions work only when the debug mode is yes
- (void) called:(NSMutableString *)functionName;
- (void) enter:(NSMutableString *)functionName;
- (void) exit:(NSMutableString *)functionName;

@end
