//
//  SLogger.m
//  BBSApp
//
//  Created by Kiwoon Sung on 7/29/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "SLogger.h"


@implementation SLogger

@synthesize className = m_className;
@synthesize isDebugMode = m_isDebugMode;

- (id) initWithClassName: (NSString *)className isDebugMode:(BOOL)flag {
    self.className = className;
    self.isDebugMode = flag;
 
    return self;
}

- (void) output: (NSString *)message showUpOnlyOnDebugMode:(BOOL)flag {
    if (flag) {
        // Only if self.showUpOnlyOnDebugMode is true, the message is printed.
        if (self.isDebugMode) {
            [self output:message];
        }
    }
    else {
        [self output:message];
    }
}

// Call this method if you want to print the message no matter what the debugging mode is.
- (void) output: (NSString *)message {
    NSLog(@"[%@] %@", self.className, message);
}


- (void) outputOnlyOnDebugMode:(NSMutableString *)message {
    if (self.isDebugMode) {
        [self output:message];
    }
}


// called:enter:exit will print the message only when the showUp flag is true
- (void) called:(NSMutableString *)functionName {
    if (self.isDebugMode) {
        [self output:[@"called: " stringByAppendingString:functionName]];
    }
}
- (void) enter:(NSMutableString *)functionName {
    if (self.isDebugMode) {
        [self output:[@"enter : " stringByAppendingString:functionName]];
    }
}

- (void) exit:(NSMutableString *)functionName {
    if (self.isDebugMode) {
        [self output:[@"exit  : " stringByAppendingString:functionName]];
    }
}


@end
