//
//  ServerItemTableViewController.h
//  BBSApp
//
//  Created by Ki Woon Sung on 7/25/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "Item.h"
#import "ItemViewController.h"

@interface ServerItemTableViewController : UITableViewController {
	NSMutableArray *list; // this is only for composing the menu list based on the item information list
    NSMutableArray *listItemInformation; // this is the mutable array to keep the item information list from the server
    BOOL _isDataSourceAvailable;

    ItemViewController *itemViewController;
    UIScrollView *containerView;
    
    UIActivityIndicatorView *_activityIndicatorView;
    UIToolbar *toolbar;
}

@property (nonatomic, retain) NSMutableArray *list;
@property (nonatomic, retain) NSMutableArray *listItemInformation;
@property (nonatomic, retain) UIActivityIndicatorView *activityIndicatorView;
@property (nonatomic, retain) ItemViewController *itemViewController;
@property (nonatomic, retain) UIScrollView *containerView;

- (void)sendHTTPRequestSync;
- (void)generateItemInstanceByXMLTest;
- (void)generateItemInformationListByXML; // this generates the member, listItemInformation if the parsed XML has no error. 
- (BOOL)isDataSourceAvailable;
- (void)getItemListData;
- (void)showActivityIndicator;
- (void)hideActivityIndicator;
- (void)showTableHeader;
- (void)showTableFooter;


@end
