//
//  ServerItemTableViewControllerR2.h
//  BBSApp
//
//  Created by Kiwoon Sung on 8/1/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "ItemViewController.h"

@interface ServerItemTableViewControllerR2 : UIViewController <UITableViewDelegate, UITableViewDataSource> {
    NSMutableArray *list;
    NSMutableArray *listItemInformation; // this is the mutable array to keep the item information list from the server
    
    BOOL _isDataSourceAvailable;
    BOOL didLaunchHTTPDaemon;
    
    // Response from the server
    NSMutableData *_receivedData;
    
    ItemViewController *itemViewController;
        
    UIToolbar *toolbar;
    UITableView *tableViewMember; // Don't use "tableView" as the name of the contained table view. It conflicts...
    UIActivityIndicatorView *_activityIndicatorView;
}

@property (nonatomic, retain) NSMutableArray *list;
@property (nonatomic, retain) NSMutableArray *listItemInformation;
@property (nonatomic, retain) UIActivityIndicatorView *activityIndicatorView;
@property (nonatomic, retain) ItemViewController *itemViewController;
@property (nonatomic, retain) UITableView *tableViewMember;
@property (nonatomic, retain) NSMutableData *receivedData;

- (void)createToolbarItems;
- (void)generateTableEntries;
- (void)showTableFooter;

// Methods from the revision 1
- (void)generateItemInstanceByXMLTest;
- (void)generateItemInformationListByXML; // this generates the member, listItemInformation if the parsed XML has no error. 
- (void)generateItemListInformationByURL;
- (void)reloadItemInformationList:(NSData *)receivedData;
- (BOOL)isDataSourceAvailable;
- (void)showActivityIndicator;
- (void)hideActivityIndicator;
- (void)showTableHeader;
- (void)showTableFooter;
- (void)refreshTable;
- (void)displayStatusOnToolbar:(NSString *)text 
                 showIndicator:(BOOL)showIndicator
                showStopButton:(BOOL)showStopButton
             showRefreshButton:(BOOL)showRefreshButton;


// Trial
- (void)checkCommandsAvailability;

// Prototypes for the web server
- (void)runHTTPService:(id)sender;
- (void)launchHTTPDaemon;
static void signal_handler(int sig_num);



@end
