//
//  ServiceInformation.m
//  BBSApp
//
//  Created by Kiwoon Sung on 8/3/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import "ServiceInformation.h"


@implementation ServiceInformation


@synthesize netService = _netService;
@synthesize items;
@synthesize count;

- (id) init
{
    self = [super init];
    if (self != nil) {
        self.items = [[NSMutableArray alloc]initWithCapacity:10];
    }
    return self;
}


- (id)initWithNetService:(NSNetService *)netService {
    self = [super init];
    if (self != nil) {
        self.netService = netService;
        self.items = [[NSMutableArray alloc]initWithCapacity:10];
        
        // new txt record: "count" describes how many items in this service.
        NSDictionary *countDic = [[NSDictionary alloc]init];
        countDic = [NSDictionary dictionaryWithDictionary:[NSNetService dictionaryFromTXTRecordData:[netService TXTRecordData]]];
        self.count = (NSUInteger)[NSString stringWithFormat:@"%d", [countDic valueForKey:@"count"]];
        NSLog(@"count::", self.count);
    }
    return self;
}


- (id)initWithService:(ServiceInformation *)service {
    self = [super init];
    if (self != nil) {
        self.netService = service.netService;
        
        self.items = [[NSMutableArray alloc]initWithCapacity:[service.items count]];
        self.items = service.items;
//        self.items = service.items;//initWithArray:service.items copyItems:YES];
    }
    return self;
}

- (void)dealloc {
    [self.items release];
    [self.netService release];
    
    [super dealloc];
}
    

- (NSString *)getServiceName {
    return [self.netService name];
}


- (void)addTXTRecordData:(NSData *)data {
    if (data != nil) {
        [self.items addObject:data];
    }
}



@end
