//
//  ServiceTableViewController.h
//  BBSApp
//
//  Created by Ki Woon Sung on 7/25/08.
//  Copyright 2008 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "PeerItemTableViewController.h"

@interface ServiceTableViewController : UITableViewController {
    // Internal data
    NSMutableArray *listItemInformation;
    
    // Extra views
    UIToolbar *toolbar;
    UITableView *tableViewMember; // Should use the postfix otherwise the name will conflict
    UIActivityIndicatorView *_activityIndicatorView;
    
    // Selected item view controller;
    PeerItemTableViewController *peerItemTableViewController;
    
    //-- Zeroconf
    NSNetServiceBrowser *_netServiceBrowser;
    // Keep track of available services
    // NSMutableArray *_netServices; // Don't define a new member. Use listItemInformation instead.
    
    // Kepp track of search status
    BOOL searching;
    NSUInteger countServices;
    
}


@property (nonatomic, retain) NSMutableArray *listItemInformation;
@property (nonatomic, retain) UIActivityIndicatorView *activityIndicatorView;
@property (nonatomic, retain) PeerItemTableViewController *peerItemTableViewController;
@property (nonatomic, retain) UITableView *tableViewMember;
@property (nonatomic, retain) NSNetServiceBrowser *netServiceBrowser;

- (void)showTableFooter;
- (void)displayStatusOnToolbar:(NSString *)text 
                 showIndicator:(BOOL)showIndicator
                showStopButton:(BOOL)showStopButton
             showRefreshButton:(BOOL)showRefreshButton;

- (void)updateListItemInformation;

// Trial
- (void)printTrialInformation;

- (void)setNetServiceBrowser:(NSNetServiceBrowser*)newBrowser;
- (NSNetServiceBrowser*)netServiceBrowser;
- (BOOL)commonSetup;
- (BOOL)searchForBrowsableDomains;
- (BOOL)searchForRegistrationDomains;
- (void)handleError:(NSNumber *)error;
- (NSString*) transmogrify:(NSString*)aString;
- (void)netServiceBrowser:(NSNetServiceBrowser*)netServiceBrowser didRemoveDomain:(NSString*)domain moreComing:(BOOL)moreComing;
- (void)netServiceBrowser:(NSNetServiceBrowser*)netServiceBrowser didFindDomain:(NSString*)domain moreComing:(BOOL)moreComing;
- (void)reloadNetServices;
- (BOOL)removeServiceByNetService:(NSNetService *)netService;
- (void)printItemInformationList;
- (void)refreshAction:(id)sender;

@end
